// C Source File
// Created 27/06/2003; 09:41:28

#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200 							// Compile for V200
#define NO_EXIT_SUPPORT       // Les instructions 'exit' et 'atexit' ne peuvent ainsi plus fonctionner et a fait encore gagner de la place !
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define MIN_AMS 100           // Compile for AMS 1.00 or higher
#include <tigcclib.h>         // Include All Header Files

/*==================================================================================*/
//																																									//
//						Programme ralis sans aucune ligne d'assembleur!!!										//
//																																									//
/*==================================================================================*/


//-------------------------- Structure des Highscores ------------------------------//

typedef struct
  {
    char nom[8];
    long score;
  } HIGH_SCORES;

static HIGH_SCORES high[5]={
													{"Nul     ", 1945},
													{"Nul     ", 1914},
													{"Nul     ", 1870},
													{"Nul     ", 1789},
													{"Nul     ", 1492},
};

//----------------------------- Dfinition des images ------------------------------//

static unsigned char titre[] = {0, 28, 0, 112,
0xFF,0xFD,0xF0,0xF8,0x07,0xE0,0x01,0xFC,0x00,0x03,0xF1,0xF0,0x00,0x1F,0xFF,0xFD,0xF0,0xF8,0x1F,0xF8,0x03,0xFE,0x00,0x07,0xE1,0xF0,0x00,0x3E,0xFF,0xFD,0xF0,0xF8,0x3F,0xFC,0x07,0xFF,0x00,0x0F,0xC1,0xF0,0x00,0x7C,0xFF,0xFD,0xF0,0xF8,0x3F,0xFC,0x0F,0xFF,0x00,0x0F,0x81,0xF0,0x00,0xF8,0x0F,0x81,0xF0,0xF8,0x7E,0xFE,0x0F,0xDF,0x80,0x1F,0x01,0xF0,0x01,0xF0,0x0F,0x81,0xF0,0xF8,0x7C,0x7E,0x1F,0x8F,0x80,0x3E,0x01,0xF0,0x03,0xF0,0x0F,0x81,0xF0,0xF8,0x7C,0x3E,0x1F,0x0F,0x80,0x3E,0x01,0xF0,0x03,0xE0,0x0F,0x81,0xF0,0xF8,0x7C,0x3E,0x1F,0x0F,0x80,0x7C,0x01,0xF0,0x07,0xE0,0x0F,0x81,0xF0,0xF8,0x7C,0x3E,0x1F,0x0F,0x80,0x7C,0x01,0xF0,0x07,0xC0,0x0F,0x81,0xF0,0xF8,0x7C,0x3E,0x1F,0x0F,0x80,0xF8,0x01,0xF0,0x07,0xC0,0x0F,0x81,0xF0,0xF8,0x7C,0x3E,0x1F,0x0F,0x80,0xF8,0x01,0xF0,0x0F,0x80,0x0F,0x81,0xF0,0xF8,0x7C,0x3E,0x1F,0x0F,0x80,0xF8,0x01,0xF0,0x0F,0x80,0x0F,0x81,0xF0,0xF8,0x7C,0x3E,0x1F,0x0F,0x80,0xF8,0x01,0xF0,0x0F,0x80,0x0F,0x81,0xF0,0xF8,0x7C,0x3E,0x1F,0x0F,0x81,0xF8,0x01,0xF0,0x0F,0x80,0x0F,0x81,0xF0,0xF8,0x7C,0x3E,0x1F,0x0F,0x81,0xF0,0x01,0xF0,0x0F,0x80,0x0F,0x81,0xF0,0xF8,0x7C,0x3E,0x1F,0x0F,0x81,0xF0,0x01,0xF0,0x0F,0x80,0x0F,0x81,0xF0,0xF8,0x7C,0x3E,0x1F,0x0F,0x8F,0xFF,0xE1,0xF0,0x0F,0x80,0x0F,0x81,0xF0,0xF8,0x7C,0x3E,0x1F,0x0F,0x9F,0xFF,0xE1,0xF0,0x0F,0x80,0x0F,0x81,0xF0,0xF8,0x7C,0x3E,0x1F,0x0F,0x9F,0xFF,0xC1,0xF0,0x0F,0x80,0x0F,0x81,0xF0,0xF8,0x7C,0x3E,0x1F,0x0F,0xBF,0xFF,0xC1,0xF0,0x0F,0x80,0x0F,0x81,0xF0,0xF8,0x7C,0x3E,0x1F,0x0F,0x80,0xF8,0x01,0xF0,0x0F,0xC0,0x0F,0x81,0xF1,0xF8,0x7C,0x3E,0x1F,0x0F,0x80,0xFC,0x01,0xF0,0x07,0xC0,0x0F,0x81,0xF1,0xF8,0x7C,0x3E,0x1F,0x0F,0x80,0x7C,0x01,0xF0,0x07,0xE0,0x0F,0x81,0xFF,0xF0,0x7C,0x3E,0x1F,0x0F,0x80,0x7E,0x01,0xF0,0x03,0xE0,0x0F,0x80,0xFF,0xF0,0x7C,0x3E,0x1F,0x0F,0x80,0x3F,0x01,0xFF,0xE3,0xF0,0x0F,0x80,0xFF,0xE0,0x7C,0x3E,0x1F,0x0F,0x80,0x1F,0x81,0xFF,0xC1,0xF8,0x0F,0x80,0x7F,0xC0,0x7C,0x3E,0x1F,0x0F,0x80,0x0F,0xC1,0xFF,0xC0,0xFC,0x0F,0x80,0x1F,0x80,0x7C,0x3E,0x1F,0x0F,0x80,0x07,0xE1,0xFF,0x80,0x7E};

static unsigned char curseur[] = {0x00,0x00,0x00,0x18,0x3C,0x7E,0xFF,0xFF};

//----------------------------------------------------------------------------------//

void DrawBox(short x, short y, short width, short height, short mode)
{
	DrawClipRect(MakeWinRect(x, y, x+width, y+height), ScrRect, mode);
}

//----------------------------------------------------------------------------------//

void InputStr(long score, short choice)
{
	char nom[] = "        ";
	short key;
	short dim;
	
	dim = 0;
	
	FontSetSys(2);
	DrawStr(63, 64, "New Highscore!", 4);
	FontSetSys(1);
	DrawStr(80, 80, "Name:", 4);
	
	do
	{
		
		DrawStr(111, 80, nom, 4);
		key = ngetchx();
		
		if(key >= 18 && key <= 255 && dim < 8)
		{
			nom[dim] = key;
			dim++;
		}
		else if(key == KEY_BACKSPACE && dim > 0)
		{
			dim--;
			nom[dim] = 32;
		}
		else if(key == KEY_CLEAR)
		{
			memset(nom, 32, 8);
			dim = 0;
		}
		
	}while(key != KEY_ENTER);
	
	high[choice].score = score;
	memcpy(&high[choice].nom, &nom, sizeof(high[choice].nom));
	ScrRectFill(&(SCR_RECT){{63, 61, 175, 89}}, ScrRect, A_REVERSE);
}

//----------------------------------------------------------------------------------//

void DrawNewLines(short *x, short y, short largeur)
{
	short b;
	short c;
	
	b = random(31);
	c = random(4);
	
	if(b > 15 && *x+c+largeur < 238)
	{
		*x += c;
	}
	else if(b < 15 && *x-c > 1)
	{
		*x -= c;
	}
	
	DrawLine(0, y, *x, y, 4);
	DrawLine(*x+largeur, y, 239, y, 4);

}

//----------------------------- Boucle du jeu --------------------------------------//

long jeu(short choice)
{
	ClrScr();
	randomize();
	OSSetSR(0x0700);
	FontSetSys(1);
	char *VScreen_1 = NULL;	// Virtual Screen pour le tunnel
	char *VScreen_2 = NULL;	// Virtual Screen pour le curseur
	VScreen_1 = malloc(3870);
	VScreen_2 = malloc(LCD_SIZE);
	PortSet(VScreen_1, 239, 127);
	short i;
	short x;
	short x_curseur;
	short largeur;
	short liste_speed[] = {5000, 3000, 1500, 500, 0};
	long score;
	char buffer[3540]; // 3540 = 118*30
		
	largeur = 71;
	score = 0;
	x = 85;
	x_curseur = 116;
	
	memcpy(VScreen_1, LCD_MEM, LCD_SIZE);
	
	printf_xy(4, 121, "Level:%d", choice);
	printf_xy(108, 121, "Tunnelc by Nul v1.00");
	
	for(i = 119; i >= 0; i--)
	{
		DrawLine(0, i, x, i, 4);
		DrawLine(x+largeur, i, 239, i, 4);
	}
	
	while(!_keytest(RR_ESC))				// ESCAPE
	{
		
		if((score++)%300 == 0)
		{
			largeur--;
			printf_xy(54, 121, "Width:%d", largeur);
		}
																							
		memcpy(buffer, VScreen_1, 3540);	// 2 lignes scrolles
		memcpy(VScreen_1+60, buffer, 3540);	
																						
		DrawLine(0, 0, 239, 0, 0);
		DrawLine(0, 1, 239, 1, 0);					
		DrawNewLines(&x, 0, largeur);
		DrawNewLines(&x, 1, largeur);
									
		if(_keytest(RR_RIGHT))	// RIGHT
		{							
			x_curseur++;																				
		}
		else if(_keytest(RR_LEFT))	// LEFT
		{
			x_curseur--;
		}
		else if(_keytest(RR_APPS))
		{
			off();
		}
		
		if(GetPix(x_curseur, 119) || GetPix(x_curseur+7, 119))
		{
			break;
		}
		
		memcpy(VScreen_2, VScreen_1, LCD_SIZE);
		Sprite8(x_curseur, 112, 8, curseur, VScreen_2, SPRT_OR);
		memcpy(LCD_MEM, VScreen_2, LCD_SIZE);
		
		for(i = 0; i <= liste_speed[choice]; i++)	// Boucle d'attente
		{
		}
		
	}
	
	OSSetSR(0x0000);
	free(VScreen_1);
	free(VScreen_2);
	PortRestore();
	FontSetSys(2);
	ScrRectFill(&(SCR_RECT){{71, 46, 169, 81}}, ScrRect, A_REVERSE);
	ScrRectFill(&(SCR_RECT){{0, 121, 239, 127}}, &(SCR_RECT){{0, 0, 239, 127}}, A_REVERSE);
	DrawBox(72, 47, 96, 33, 65);
	DrawBox(75, 50, 90, 27, 15);
	DrawStr(80, 54, "GAME OVER!", 4);
	FontSetSys(1);
	DrawStr(86, 67, "Score:", 4);
	printf_xy(122 ,67, "%05lu", score);
	DrawStr(0, 121, "Press [ENTER] to continue...", 4);
	while(ngetchx() != KEY_ENTER)
	{
	}
	
	return score;
}

//------------------- Fonction appele au lancement du jeu -------------------------//

void _main(void)
{
	FILE *fp = NULL;
	LCD_BUFFER screen;
	LCD_save(screen);
	const char *levels[] = {"VERY EASY", "EASY", "MEDIUM", "HARD", "VERY HARD"};
	short key;
	short choice;
	long score;
	
	EM_moveSymFromExtMem(SYMSTR("tunnsauv"), HS_NULL); // Dsarchive la variable 'tunnsauv'
	if((fp = fopen("tunnsauv", "r+b")))
	{
		fread(high, sizeof(high), 1, fp);
		fclose(fp);
	}
	
	choice = 0;
	score = 0;
	
	Debut:
	
	ClrScr();
	DrawBox(0, 0, 238, 120, 204);	
	BitmapPut(61, 7, titre, ScrRect, 4);
	FontSetSys(0);
	DrawStr(173, 30, "By Nul", 4);
	DrawBox(57, 59, 124, 32, 113);
	if(score > high[choice].score)
	{
		InputStr(score, choice);
	}
	FontSetSys(2);
	DrawStr(68, 64, "Level:", 4);
	FontSetSys(1);
	
	do
	{
	  printf_xy(118, 66, "%-9s", levels[choice]);
	  printf_xy(68, 80, "%05lu by %s", high[choice].score, high[choice].nom);
	  
		key = ngetchx();
		
		if(key == KEY_ENTER)
		{
			score = jeu(choice);
			goto Debut;
		}
		else if(key == KEY_LEFT)
		{
			choice = choice == 0? 4: choice-1;
		}
		else if(key == KEY_RIGHT)
		{
			choice = choice == 4? 0: choice+1;
		}
	
	}while(key != KEY_ESC);
	
	fp = fopen("tunnsauv", "w+b");
	fwrite(high, sizeof(high), 1, fp);
	fputc(0, fp);
	fputs("SAUV", fp);
	fputc(0, fp);
	fputc(OTH_TAG, fp);		
	fclose(fp);
	EM_moveSymToExtMem(SYMSTR("tunnsauv"), HS_NULL); // Archive la variable 'tunnsauv'
	LCD_restore(screen);
	ST_helpMsg("Tunnelc by Nul v1.00");
}

//----------------------------------------------------------------------------------//